<?php
/**
 * Déclaration de la classe CommandLine\Argument\ParseResult.
 */
namespace jrosset\CommandLine\Argument;

/**
 * Résultat du parsage d'un argument
 *
 * @package CommandLine\Argument
 */
class ParseResult {
    /**
     * @var int Le nombre d'argument consumé.
     */
    protected int $consume;
    /**
     * @var mixed La valeur.
     */
    protected $value;

    /**
     * ArgumentParseResult constructor.
     *
     * @param mixed $value   La valeur.
     * @param int   $consume Le nombre d'argument consumé.
     */
    public function __construct ($value, int $consume = 1) {
        $this->setValue($value);
        $this->setConsume($consume);
    }

    /**
     * Le nombre d'argument consumé.
     *
     * @return int Le nombre d'argument consumé.
     *
     * @see $consume
     */
    public function getConsume (): int {
        return $this->consume;
    }
    /**
     * Définit le nombre d'argument consumé.
     *
     * @param $consume int Le nombre d'argument consumé.
     *
     * @return $this
     *
     * @see $consume
     */
    public function setConsume (int $consume): self {
        $this->consume = $consume;
        return $this;
    }

    /**
     * La valeur.
     *
     * @return mixed La valeur.
     *
     * @see $value
     */
    public function getValue() {
        return $this->value;
    }
    /**
     * Définit les valeurs définies.
     *
     * @param mixed $value La valeur.
     *
     * @return $this
     *
     * @see $value
     */
    public function setValue ($value): self {
        $this->value = $value;
        return $this;
    }
}